"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isAsyncDefaultValue = exports.hasAsyncDefaultValues = void 0;
function hasAsyncDefaultValues(resolvedInputs, asyncResolvers) {
    return resolvedInputs.some((input) => !!input.defaultsTo &&
        isAsyncDefaultValue(input.defaultsTo, asyncResolvers));
}
exports.hasAsyncDefaultValues = hasAsyncDefaultValues;
function isAsyncDefaultValue(defaultsTo, asyncResolvers) {
    switch (defaultsTo.kind) {
        case 'pda':
            return true;
        case 'resolver':
            return asyncResolvers.includes(defaultsTo.name);
        case 'conditional':
        case 'conditionalResolver':
            if (defaultsTo.kind === 'conditionalResolver' &&
                asyncResolvers.includes(defaultsTo.resolver.name)) {
                return true;
            }
            return ((defaultsTo.ifFalse == null
                ? false
                : isAsyncDefaultValue(defaultsTo.ifFalse, asyncResolvers)) ||
                (defaultsTo.ifTrue == null
                    ? false
                    : isAsyncDefaultValue(defaultsTo.ifTrue, asyncResolvers)));
        default:
            return false;
    }
}
exports.isAsyncDefaultValue = isAsyncDefaultValue;
//# sourceMappingURL=asyncHelpers.js.map