"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAccountFetchHelpersFragment = void 0;
const shared_1 = require("../../../shared");
const common_1 = require("./common");
function getAccountFetchHelpersFragment(accountNode, manifest) {
    const decoderFunctionFragment = accountNode.data.link
        ? manifest.decoder.clone()
        : (0, common_1.fragment)(`get${(0, shared_1.pascalCase)(accountNode.data.name)}Decoder()`);
    return (0, common_1.fragmentFromTemplate)('accountFetchHelpers.njk', {
        pascalCaseName: (0, shared_1.pascalCase)(accountNode.name),
        decoderFunction: decoderFunctionFragment.render,
    })
        .mergeImportsWith(decoderFunctionFragment)
        .addImports('solanaAddresses', ['Address'])
        .addImports('shared', ['Context'])
        .addImports('solanaAccounts', [
        'assertAccountExists',
        'decodeAccount',
        'EncodedAccount',
        'FetchAccountConfig',
        'FetchAccountsConfig',
    ]);
}
exports.getAccountFetchHelpersFragment = getAccountFetchHelpersFragment;
//# sourceMappingURL=accountFetchHelpers.js.map